﻿using GridDataExport.Model;
using Syncfusion.SfDataGrid.XForms.Exporting;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace GridDataExport
{

    public partial class MainPage : ContentPage
    {

        public List<TrendModel> itemList { get; set; }
        public MainPage()
        {
            InitializeComponent();

            FillTestData();
        }


        public void FillTestData() 
        {
            itemList = new List<TrendModel>();
            for (int i = 0; i < 50; i++) 
            {
                itemList.Add(new TrendModel() { DateTime = DateTime.Now, Value = i });
            }

            this.DataGrid.ItemsSource = itemList;
        }



        private async void ExportToExcel_Clicked(object sender, EventArgs e)
        {
            DataGridExcelExportingController excelExport = new DataGridExcelExportingController();
            var excelEngine = excelExport.ExportToExcel(this.DataGrid);
            var workbook = excelEngine.Excel.Workbooks[0];
            MemoryStream stream = new MemoryStream();
            workbook.SaveAs(stream);
            workbook.Close();
            excelEngine.Dispose();


            try
            {
                Xamarin.Forms.DependencyService.Get<ISave>().Save("grid.xlsx", "application/msexcel", stream);
            }
            catch (Exception exe)
            {
                string err = exe.Message;
                await DisplayAlert("Error", "Something went wrong.", "Ok");
            }
        }

        private async void ExportToPDF_Clicked(object sender, EventArgs e)
        {
            DataGridPdfExportingController pdfExport = new DataGridPdfExportingController();
            MemoryStream stream = new MemoryStream();
            var exportToPdf = pdfExport.ExportToPdf(this.DataGrid, new DataGridPdfExportOption()
            {
                FitAllColumnsInOnePage = true,
            });
            exportToPdf.Save(stream);
            exportToPdf.Close(true);

            try
            {
                Xamarin.Forms.DependencyService.Get<ISave>().Save("DataGrid.pdf", "application/pdf", stream);
            }
            catch (Exception exe)
            {
                string err = exe.Message;
                await DisplayAlert("Error", "Something went wrong.", "Ok");
            }
        }


    }
}
